/*****************************************************
 Project :
 Version :
 Date    : 6.7.2014
 Author  :
 Company :
 Comments:

 *****************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/sleep.h>
#include <avr/wdt.h>

#define ADC_VREF_TYPE 0x20

//****************************************************************

void _delay_s(int sec) {
	for (int c = 0; c < sec * 10; c++)
		_delay_ms(100/6); //2 = 28,8Hz(34,72222ms) (1=17,3611111ms) 17.37
}

// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
_delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}


int main(void) {

	// Input/Output Ports initialization
	// Port B initialization

	DDRB |= (1 << PB4);	//out

	PORTB |= (1 << PB0);	//pull up pro button


	// Analog Comparator initialization
	// Analog Comparator: Off
	ACSR=0x80;
	ADCSRB=0x00;

	// ADC initialization
	// ADC Clock frequency: 31,250 kHz
	// ADC Bandgap Voltage Reference: Off
	// ADC Auto Trigger Source: None
	// Only the 8 most significant bits of
	// the AD conversion result are used
	// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
	DIDR0&=0x03;
	DIDR0|=0x00;
	ADMUX=ADC_VREF_TYPE & 0xff;
	ADCSRA=0x87;



	//PB3 pushbutton
	//PB4 triak

	_delay_ms(10);

	while (1) {

		if((PINB & (1<<PB0))==0){

			int a = read_adc(1);

			PORTB |= (1 << PB4);//preweld
			_delay_ms(2);
			PORTB &= 0xFF - (1 << PB4);



			_delay_ms(20);//pause



			PORTB |= (1 << PB4);//weld

			for(int i=0;i<a;i++){
				_delay_us(400);
			}

			PORTB &= 0xFF - (1 << PB4);

			_delay_s(1);
			while((PINB & (1<<PB0))!=0);
		}
	};
}
